import { Injectable } from '@nestjs/common';
import { QueueDataService } from '../data/services/queue.service';
import { IndexQueueManager } from './usecases/index-queue.manager';
import { PaginationResponse } from 'src/core/response/domain/ok-response.interface';
import { Queue } from './entities/queue.entity';
import { TABLE_NAME } from 'src/core/strings/constants/table.constants';

@Injectable()
export class QueueAdminOrchestrator {
  constructor(
    private readonly dataService: QueueDataService,
    private indexManager: IndexQueueManager,
  ) {}

  async index(params): Promise<PaginationResponse<Queue>> {
    this.indexManager.setFilterParam(params);
    this.indexManager.setService(this.dataService, TABLE_NAME.QUEUE);
    await this.indexManager.execute();
    return this.indexManager.getResult();
  }
}
